DROP TABLE IF EXISTS `%TABLE_PREFIX%tinymce_profiles`;

CREATE TABLE IF NOT EXISTS `%TABLE_PREFIX%tinymce_profiles` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `configuration` text NOT NULL default '',
  `ptype` tinyint(4) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

--
--
--

INSERT INTO `%TABLE_PREFIX%tinymce_profiles` (`id`, `name`, `description`, `configuration`, `ptype`) VALUES(1, 'css', 'CSS fuer den TinyMCE', '/* ---------------------- */\r\n/* TinyMCE specific rules */\r\n/* ---------------------- */\r\nbody.mceContentBody {\r\n	background: #fff;\r\n	font-family: Verdana, Arial, Helvetica, sans-serif;\r\n	font-size: 12px;\r\n}\r\n.mceContentBody a {\r\n   color: #009 !important; /* FF requires a important here */\r\n}\r\n\r\n\r\n/* -------------------------- */\r\n/* Ab hier die eigenen Styles */\r\n/* -------------------------- */\r\np {\r\n	font-family: Verdana, Arial, Helvetica, sans-serif;\r\n	font-size: 12px;\r\n}\r\n\r\n.Beispiel1 {\r\n	font-weight: bold;\r\n	color: #c00;\r\n	font-size: 14px;\r\n}\r\n\r\n.Beispiel2 {\r\n	font-weight: bold;\r\n	color: #090;\r\n}\r\n\r\n.Beispiel3 {\r\n	font-weight: bold;\r\n	color: #009;\r\n}', 1);
INSERT INTO `%TABLE_PREFIX%tinymce_profiles` (`id`, `name`, `description`, `configuration`, `ptype`) VALUES(2, 'default', 'Standard TinyMCE-Konfiguration', '// Pfad zum TinyMCE-Script\r\n//\r\n// Bei der Verwendung des TinyMCE im Frontend, oder bei Installation in einem\r\n// Unterverzeichnis (z.B.: cms) muss hier evtl. der absolute Pfad angegeben werden\r\n// Im Frontend muss noch zusaetzlich jQuery eingebunden werden\r\n// z.B.: <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>\r\n//\r\nscript_url : ''%HTDOCS_PATH%files/addons/tinymce/tiny_mce/tiny_mce.js'',\r\n\r\n// Sprache\r\nlanguage: ''de'',\r\n\r\n// Theme-Optionen\r\ntheme : ''advanced'',\r\ntheme_advanced_toolbar_location : ''top'',\r\ntheme_advanced_toolbar_align : ''left'',\r\ntheme_advanced_statusbar_location : ''bottom'',\r\ntheme_advanced_resizing : true,\r\n\r\n// Plugins\r\n// inlinepopups hinzufuegen fuer Popups im Lightbox-Stil\r\n// contextmenu entfernen um das Kontext-Menue (Rechts-Klick) zu deaktivieren\r\nplugins : ''advhr,advimage,advlink,contextmenu,fullscreen,paste,preview,visualchars,redaxo,media,emotions'',\r\n\r\n// Buttons\r\ntheme_advanced_buttons1 : ''bold,italic,underline,strikethrough,sub,sup,|,forecolor,backcolor,styleselect,formatselect,|,charmap,cleanup,removeformat,|,preview,code,fullscreen'',\r\ntheme_advanced_buttons2 : ''cut,copy,paste,pastetext,pasteword,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,|,link,unlink,redaxoMedia,redaxoEmail,anchor,|,advhr,image'',\r\ntheme_advanced_buttons3 : '''',\r\ntheme_advanced_buttons4 : '''',\r\n\r\n// Eigener CSS fuer den Tiny - hier bei Bedarf den eigenen Pfad angeben\r\ncontent_css : ''%FRONTEND_FILE%?tinymcecss=true'',\r\n\r\n//document_base_url : ''http://localhost/'',\r\n//document_base_url : ''%SERVER%'',\r\nrelative_urls : true,\r\nfile_browser_callback : ''TinyMCE_FileBrowser'',\r\n\r\n// Beispiele fuer Farben und Formatauswahl\r\n/*\r\ntheme_advanced_text_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_foreground_color : ''#000000'',\r\ntheme_advanced_background_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_background_color : ''#FFFFFF'',\r\ntheme_advanced_blockformats : ''Absatz=p,\\u00dcberschrift 1=h1,\\u00dcberschrift 2=h2,\\u00dcberschrift 3=h3'',\r\n*/\r\n\r\n// Groessen fuer Popup-Fenster\r\nplugin_preview_width : 800,\r\nplugin_preview_height : 600,\r\ntemplate_popup_width : 800,\r\ntemplate_popup_height : 600,\r\ntheme_advanced_source_editor_width : 800,\r\ntheme_advanced_source_editor_height : 600,\r\n\r\n// sonstige Optionen\r\nentity_encoding : ''raw'',\r\nmedia_use_script : true,\r\naccessibility_warnings : false,\r\nfix_list_elements : true,\r\ndialog_type : ''modal''\r\n', 0);
INSERT INTO `%TABLE_PREFIX%tinymce_profiles` (`id`, `name`, `description`, `configuration`, `ptype`) VALUES(3, 'simple', 'Einfache TinyMCE-Konfiguration', '// Pfad zum TinyMCE-Script\r\n//\r\n// Bei der Verwendung des TinyMCE im Frontend, oder bei Installation in einem\r\n// Unterverzeichnis (z.B.: cms) muss hier evtl. der absolute Pfad angegeben werden\r\n// Im Frontend muss noch zusaetzlich jQuery eingebunden werden\r\n// z.B.: <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>\r\n//\r\nscript_url : ''%HTDOCS_PATH%files/addons/tinymce/tiny_mce/tiny_mce.js'',\r\n\r\n// Sprache\r\nlanguage: ''de'',\r\n\r\n// Theme-Optionen\r\ntheme : ''advanced'',\r\ntheme_advanced_toolbar_location : ''top'',\r\ntheme_advanced_toolbar_align : ''left'',\r\ntheme_advanced_statusbar_location : ''bottom'',\r\ntheme_advanced_resizing : true,\r\n\r\n// Plugins\r\n// inlinepopups hinzufuegen fuer Popups im Lightbox-Stil\r\n// contextmenu entfernen um das Kontext-Menue (Rechts-Klick) zu deaktivieren\r\nplugins : ''advhr,advimage,advlink,contextmenu,fullscreen,paste,preview,visualchars,redaxo,media,emotions'',\r\n\r\n// Buttons\r\ntheme_advanced_buttons1 : ''bold,italic,underline,strikethrough,sub,sup,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,|,link,unlink,redaxoMedia,redaxoEmail,anchor,|,advhr,image,|,preview'',\r\ntheme_advanced_buttons2 : '''',\r\ntheme_advanced_buttons3 : '''',\r\ntheme_advanced_buttons4 : '''',\r\n\r\n// Eigener CSS fuer den Tiny - hier bei Bedarf den eigenen Pfad angeben\r\ncontent_css : ''%FRONTEND_FILE%?tinymcecss=true'',\r\n\r\n//document_base_url : ''http://localhost/'',\r\n//document_base_url : ''%SERVER%'',\r\nrelative_urls : true,\r\nfile_browser_callback : ''TinyMCE_FileBrowser'',\r\n\r\n// Beispiele fuer Farben und Formatauswahl\r\n/*\r\ntheme_advanced_text_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_foreground_color : ''#000000'',\r\ntheme_advanced_background_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_background_color : ''#FFFFFF'',\r\ntheme_advanced_blockformats : ''Absatz=p,\\u00dcberschrift 1=h1,\\u00dcberschrift 2=h2,\\u00dcberschrift 3=h3'',\r\n*/\r\n\r\n// Groessen fuer Popup-Fenster\r\nplugin_preview_width : 800,\r\nplugin_preview_height : 600,\r\ntemplate_popup_width : 800,\r\ntemplate_popup_height : 600,\r\ntheme_advanced_source_editor_width : 800,\r\ntheme_advanced_source_editor_height : 600,\r\n\r\n// sonstige Optionen\r\nentity_encoding : ''raw'',\r\nmedia_use_script : true,\r\naccessibility_warnings : false,\r\nfix_list_elements : true,\r\ndialog_type : ''modal''\r\n', 0);
INSERT INTO `%TABLE_PREFIX%tinymce_profiles` (`id`, `name`, `description`, `configuration`, `ptype`) VALUES(4, 'table', 'Standard TinyMCE-Konfiguration mit Tabellen', '// Pfad zum TinyMCE-Script\r\n//\r\n// Bei der Verwendung des TinyMCE im Frontend, oder bei Installation in einem\r\n// Unterverzeichnis (z.B.: cms) muss hier evtl. der absolute Pfad angegeben werden\r\n// Im Frontend muss noch zusaetzlich jQuery eingebunden werden\r\n// z.B.: <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>\r\n//\r\nscript_url : ''%HTDOCS_PATH%files/addons/tinymce/tiny_mce/tiny_mce.js'',\r\n\r\n// Sprache\r\nlanguage: ''de'',\r\n\r\n// Theme-Optionen\r\ntheme : ''advanced'',\r\ntheme_advanced_toolbar_location : ''top'',\r\ntheme_advanced_toolbar_align : ''left'',\r\ntheme_advanced_statusbar_location : ''bottom'',\r\ntheme_advanced_resizing : true,\r\n\r\n// Plugins\r\n// inlinepopups hinzufuegen fuer Popups im Lightbox-Stil\r\n// contextmenu entfernen um das Kontext-Menue (Rechts-Klick) zu deaktivieren\r\nplugins : ''advhr,advimage,advlink,contextmenu,fullscreen,paste,preview,visualchars,redaxo,media,emotions,table'',\r\n\r\n// Buttons\r\ntheme_advanced_buttons1 : ''bold,italic,underline,strikethrough,sub,sup,|,forecolor,backcolor,styleselect,formatselect,|,charmap,cleanup,removeformat,|,preview,code,fullscreen'',\r\ntheme_advanced_buttons2 : ''cut,copy,paste,pastetext,pasteword,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,|,link,unlink,redaxoMedia,redaxoEmail,anchor,|,advhr,image'',\r\ntheme_advanced_buttons3 : ''tablecontrols'',\r\ntheme_advanced_buttons4 : '''',\r\n\r\n// Eigener CSS fuer den Tiny - hier bei Bedarf den eigenen Pfad angeben\r\ncontent_css : ''%FRONTEND_FILE%?tinymcecss=true'',\r\n\r\n//document_base_url : ''http://localhost/'',\r\n//document_base_url : ''%SERVER%'',\r\nrelative_urls : true,\r\nfile_browser_callback : ''TinyMCE_FileBrowser'',\r\n\r\n// Beispiele fuer Farben und Formatauswahl\r\n/*\r\ntheme_advanced_text_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_foreground_color : ''#000000'',\r\ntheme_advanced_background_colors : ''000000,FFFFFF,CC0000,009900,000099'',\r\ntheme_advanced_default_background_color : ''#FFFFFF'',\r\ntheme_advanced_blockformats : ''Absatz=p,\\u00dcberschrift 1=h1,\\u00dcberschrift 2=h2,\\u00dcberschrift 3=h3'',\r\n*/\r\n\r\n// Groessen fuer Popup-Fenster\r\nplugin_preview_width : 800,\r\nplugin_preview_height : 600,\r\ntemplate_popup_width : 800,\r\ntemplate_popup_height : 600,\r\ntheme_advanced_source_editor_width : 800,\r\ntheme_advanced_source_editor_height : 600,\r\n\r\n// sonstige Optionen\r\nentity_encoding : ''raw'',\r\nmedia_use_script : true,\r\naccessibility_warnings : false,\r\nfix_list_elements : true,\r\ndialog_type : ''modal''\r\n', 0);
